// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package protosettlement

import (
	context "context"
	common "gitlab.com/vajar_minigame/proto_go/gen/common"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// SettlementServicesClient is the client API for SettlementServices service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type SettlementServicesClient interface {
	AddSettlement(ctx context.Context, in *Settlement, opts ...grpc.CallOption) (*Settlement, error)
	AddTestSettlement(ctx context.Context, in *Settlement, opts ...grpc.CallOption) (*Settlement, error)
	GetSettlementByID(ctx context.Context, in *common.SettlementId, opts ...grpc.CallOption) (*Settlement, error)
	GetSettlementsByUserID(ctx context.Context, in *common.UserId, opts ...grpc.CallOption) (*SettlementList, error)
	DeleteSettlement(ctx context.Context, in *common.SettlementId, opts ...grpc.CallOption) (*common.ResponseStatus, error)
	BuildBuilding(ctx context.Context, in *BuildBuildingCall, opts ...grpc.CallOption) (*common.ResponseStatus, error)
	UpgradeBuilding(ctx context.Context, in *UpgradeBuildingCall, opts ...grpc.CallOption) (*common.ResponseStatus, error)
}

type settlementServicesClient struct {
	cc grpc.ClientConnInterface
}

func NewSettlementServicesClient(cc grpc.ClientConnInterface) SettlementServicesClient {
	return &settlementServicesClient{cc}
}

func (c *settlementServicesClient) AddSettlement(ctx context.Context, in *Settlement, opts ...grpc.CallOption) (*Settlement, error) {
	out := new(Settlement)
	err := c.cc.Invoke(ctx, "/protosettlement.SettlementServices/AddSettlement", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *settlementServicesClient) AddTestSettlement(ctx context.Context, in *Settlement, opts ...grpc.CallOption) (*Settlement, error) {
	out := new(Settlement)
	err := c.cc.Invoke(ctx, "/protosettlement.SettlementServices/AddTestSettlement", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *settlementServicesClient) GetSettlementByID(ctx context.Context, in *common.SettlementId, opts ...grpc.CallOption) (*Settlement, error) {
	out := new(Settlement)
	err := c.cc.Invoke(ctx, "/protosettlement.SettlementServices/GetSettlementByID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *settlementServicesClient) GetSettlementsByUserID(ctx context.Context, in *common.UserId, opts ...grpc.CallOption) (*SettlementList, error) {
	out := new(SettlementList)
	err := c.cc.Invoke(ctx, "/protosettlement.SettlementServices/GetSettlementsByUserID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *settlementServicesClient) DeleteSettlement(ctx context.Context, in *common.SettlementId, opts ...grpc.CallOption) (*common.ResponseStatus, error) {
	out := new(common.ResponseStatus)
	err := c.cc.Invoke(ctx, "/protosettlement.SettlementServices/DeleteSettlement", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *settlementServicesClient) BuildBuilding(ctx context.Context, in *BuildBuildingCall, opts ...grpc.CallOption) (*common.ResponseStatus, error) {
	out := new(common.ResponseStatus)
	err := c.cc.Invoke(ctx, "/protosettlement.SettlementServices/BuildBuilding", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *settlementServicesClient) UpgradeBuilding(ctx context.Context, in *UpgradeBuildingCall, opts ...grpc.CallOption) (*common.ResponseStatus, error) {
	out := new(common.ResponseStatus)
	err := c.cc.Invoke(ctx, "/protosettlement.SettlementServices/UpgradeBuilding", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// SettlementServicesServer is the server API for SettlementServices service.
// All implementations must embed UnimplementedSettlementServicesServer
// for forward compatibility
type SettlementServicesServer interface {
	AddSettlement(context.Context, *Settlement) (*Settlement, error)
	AddTestSettlement(context.Context, *Settlement) (*Settlement, error)
	GetSettlementByID(context.Context, *common.SettlementId) (*Settlement, error)
	GetSettlementsByUserID(context.Context, *common.UserId) (*SettlementList, error)
	DeleteSettlement(context.Context, *common.SettlementId) (*common.ResponseStatus, error)
	BuildBuilding(context.Context, *BuildBuildingCall) (*common.ResponseStatus, error)
	UpgradeBuilding(context.Context, *UpgradeBuildingCall) (*common.ResponseStatus, error)
	mustEmbedUnimplementedSettlementServicesServer()
}

// UnimplementedSettlementServicesServer must be embedded to have forward compatible implementations.
type UnimplementedSettlementServicesServer struct {
}

func (UnimplementedSettlementServicesServer) AddSettlement(context.Context, *Settlement) (*Settlement, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AddSettlement not implemented")
}
func (UnimplementedSettlementServicesServer) AddTestSettlement(context.Context, *Settlement) (*Settlement, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AddTestSettlement not implemented")
}
func (UnimplementedSettlementServicesServer) GetSettlementByID(context.Context, *common.SettlementId) (*Settlement, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetSettlementByID not implemented")
}
func (UnimplementedSettlementServicesServer) GetSettlementsByUserID(context.Context, *common.UserId) (*SettlementList, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetSettlementsByUserID not implemented")
}
func (UnimplementedSettlementServicesServer) DeleteSettlement(context.Context, *common.SettlementId) (*common.ResponseStatus, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteSettlement not implemented")
}
func (UnimplementedSettlementServicesServer) BuildBuilding(context.Context, *BuildBuildingCall) (*common.ResponseStatus, error) {
	return nil, status.Errorf(codes.Unimplemented, "method BuildBuilding not implemented")
}
func (UnimplementedSettlementServicesServer) UpgradeBuilding(context.Context, *UpgradeBuildingCall) (*common.ResponseStatus, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpgradeBuilding not implemented")
}
func (UnimplementedSettlementServicesServer) mustEmbedUnimplementedSettlementServicesServer() {}

// UnsafeSettlementServicesServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to SettlementServicesServer will
// result in compilation errors.
type UnsafeSettlementServicesServer interface {
	mustEmbedUnimplementedSettlementServicesServer()
}

func RegisterSettlementServicesServer(s grpc.ServiceRegistrar, srv SettlementServicesServer) {
	s.RegisterService(&SettlementServices_ServiceDesc, srv)
}

func _SettlementServices_AddSettlement_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Settlement)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SettlementServicesServer).AddSettlement(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/protosettlement.SettlementServices/AddSettlement",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SettlementServicesServer).AddSettlement(ctx, req.(*Settlement))
	}
	return interceptor(ctx, in, info, handler)
}

func _SettlementServices_AddTestSettlement_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Settlement)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SettlementServicesServer).AddTestSettlement(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/protosettlement.SettlementServices/AddTestSettlement",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SettlementServicesServer).AddTestSettlement(ctx, req.(*Settlement))
	}
	return interceptor(ctx, in, info, handler)
}

func _SettlementServices_GetSettlementByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(common.SettlementId)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SettlementServicesServer).GetSettlementByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/protosettlement.SettlementServices/GetSettlementByID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SettlementServicesServer).GetSettlementByID(ctx, req.(*common.SettlementId))
	}
	return interceptor(ctx, in, info, handler)
}

func _SettlementServices_GetSettlementsByUserID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(common.UserId)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SettlementServicesServer).GetSettlementsByUserID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/protosettlement.SettlementServices/GetSettlementsByUserID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SettlementServicesServer).GetSettlementsByUserID(ctx, req.(*common.UserId))
	}
	return interceptor(ctx, in, info, handler)
}

func _SettlementServices_DeleteSettlement_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(common.SettlementId)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SettlementServicesServer).DeleteSettlement(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/protosettlement.SettlementServices/DeleteSettlement",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SettlementServicesServer).DeleteSettlement(ctx, req.(*common.SettlementId))
	}
	return interceptor(ctx, in, info, handler)
}

func _SettlementServices_BuildBuilding_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BuildBuildingCall)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SettlementServicesServer).BuildBuilding(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/protosettlement.SettlementServices/BuildBuilding",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SettlementServicesServer).BuildBuilding(ctx, req.(*BuildBuildingCall))
	}
	return interceptor(ctx, in, info, handler)
}

func _SettlementServices_UpgradeBuilding_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpgradeBuildingCall)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SettlementServicesServer).UpgradeBuilding(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/protosettlement.SettlementServices/UpgradeBuilding",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SettlementServicesServer).UpgradeBuilding(ctx, req.(*UpgradeBuildingCall))
	}
	return interceptor(ctx, in, info, handler)
}

// SettlementServices_ServiceDesc is the grpc.ServiceDesc for SettlementServices service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var SettlementServices_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "protosettlement.SettlementServices",
	HandlerType: (*SettlementServicesServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "AddSettlement",
			Handler:    _SettlementServices_AddSettlement_Handler,
		},
		{
			MethodName: "AddTestSettlement",
			Handler:    _SettlementServices_AddTestSettlement_Handler,
		},
		{
			MethodName: "GetSettlementByID",
			Handler:    _SettlementServices_GetSettlementByID_Handler,
		},
		{
			MethodName: "GetSettlementsByUserID",
			Handler:    _SettlementServices_GetSettlementsByUserID_Handler,
		},
		{
			MethodName: "DeleteSettlement",
			Handler:    _SettlementServices_DeleteSettlement_Handler,
		},
		{
			MethodName: "BuildBuilding",
			Handler:    _SettlementServices_BuildBuilding_Handler,
		},
		{
			MethodName: "UpgradeBuilding",
			Handler:    _SettlementServices_UpgradeBuilding_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "settlement.proto",
}
